'use strict';

const co = require('co');
const program = require('commander');
const args = process.argv.slice(3);
const debug = require('debug')('boat-cli:bundle');

const {checkProject} = require('../../lib/project');

program
  .parse(process.argv);


co(function*(){
  yield bundle();
}).catch(e => {
  debug(e);
  console.error(e.message);
  process.exit(1);
})


function* bundle(){    
  let checkResult = checkProject();

  if(checkResult.success) {
    const bundle = require('../../command/bundle');
    bundle.bundleCompiler();
  }else {
    if(checkResult.code == checkProject.CHECK_ERROR_NOT_BOAT_APP) {
      const ui = require('../../lib/ui');      
      console.log(ui.yellow('当前仓库的 app 配置错误，请参考文档 http://xxxx.xx.xx 调整配置或创建本地项目'));

    }else if(checkResult.code == checkProject.CHECK_ERROR_EMPTY_DIR) {
      const ui = require('../../lib/ui');
      console.log(ui.yellow(('当前目录不存在项目')));
    }
  }
}