'use strict';

const co = require('co');
const wd = require('weex-devtool');
const {devtool_server_port} = require('../../config');
const {startDevtoolServer} = require('../../command/debug');
const debug = require('debug')('boat-cli:debug');
const ui = require('../../lib/ui');

co(function*(){
  yield debugApp();
}).catch(e => {
  debug(e);
  console.error(e.message);
  process.exit(1);
})

function *debugApp(){
  console.log(ui.green('调试服务启动中...'));
  yield startDevtoolServer(devtool_server_port);
}