'use strict';

const co = require('co')
const ssh = require('../../lib/ssh-key')
const chalk = require('chalk')
const ncp = require('copy-paste')


co(function*(){
  let pubKey = yield ssh.getPubKey()
  pubKey = pubKey.replace('\n', '')

  console.log(`粘贴公钥到: ${chalk.yellow("https://boat.alibaba.com/setting#ssh-key")}`)
  console.log(`公钥文件地址: ${ssh.sshKeyLocation}.pub`)
  console.log(`公钥内容: ${chalk.yellow(pubKey)}`)

  console.log(chalk.green('自动复制中...'))
  ncp.copy(pubKey, function(err){
    if(err) {
      console.log(chalk.red('复制到剪贴板公钥失败，请手动复制粘贴终端显示内容，或打开文件复制粘贴'))
      throw err
    }
      console.log(chalk.green('复制到剪贴板公钥成功'))
  })
})
