#!/usr/bin/env node

const fs = require('fs');
const path = require('path');
const co = require('co');
const updateNotifier = require('update-notifier');
const pkg = require('../../package.json');
const program = require('commander');
const debug = require('debug')('boat-cli:boat');
const login = require('../../lib/login');
const getServer = require('../../lib/get-server');


const skipLogin = process.env.BOAT_SKIP_LOGIN || false;
const pkgVersion = JSON.parse(fs.readFileSync(path.join(__dirname, '../../package.json'), 'utf-8')).version;

const notifier = updateNotifier({pkg});
notifier.notify();

program
  .version(pkgVersion)
  // .command('init', '初始化项目', {noHelp: true})
  .command('add [pagename]', '新增页面')
  .command('dev', '项目开发调试')
  .command('bundle', 'bundle 构建', {noHelp: true})
  .command('build', '项目打包', {noHelp: true})
  .command('debug', 'devtool 调试', {noHelp: true})
  .command('ssh', '查看 ssh 公钥')

const server = getServer(process.argv);

co(function*() {
  // let loginResult = false;
  // if(!skipLogin){
  //   loginResult = yield login.login(server); 
  // }else {
  //   loginResult = true;
  // }
   
  // if(loginResult) {
    program.parse(process.argv);
  // }else {
  //   console.log('登录失败')
  // }
}).catch(e => {
  debug(e);
  console.error(e.message);
  process.exit(1);
})



