'use strict';

const s_pack = require('./pack');
const WebSocket = require('ws');
const fs = require('fs');
const path = require('path');
const log = require('./log');
const debug = require('debug')('boat-cli:build');
const got = require('got');
const FormData = require('form-data');

// 运行
exports.run = function* (opts) {
  opts = opts || {};
  const dir = process.cwd();
  const task_id = yield createTask(Object.assign(opts));
  console.log('task_id', task_id);
};

// 创建发布任务
function* createTask(options) {
  log.info('正在创建发布任务');

  const params = {
    body: {
      token: options.token,
      app_id: options.appId,
      type: 1,
      platform: 1,
      commit_id: '95dfd2ee6974a704e021c304af36ae0e63b0040c'
    },
    form: true,
    json: true,
    timeout: 5 * 1000
  }
  debug('创建参数', params);
  const result = yield got.post(`${options.server}/api/package/create`, params).then(response => response.body).catch(e => e);

  debug('创建结果', result);

  if (result instanceof Error) {
    return Promise.reject(Error(`[创建接口错误]${result.message}`));
  } else if (result.error !== '') {
    return Promise.reject(Error(`[创建失败]${result.error}`));
  }

  return result.data.id;
}