const spawn = require('cross-spawn');
const args = process.argv.slice(3);


function bundleCompiler(){
  const config = require('../../config') ;
  const dsl = config.dsl();

  if(dsl == 'react') {
    bundleReactCompiler();
  }else if(dsl == 'vue'){
    bundleVueCompiler();
  }
}

function bundleVueCompiler(){
  const bundleScript = require.resolve('./vue/index');
  
  let result = spawn.sync(
    'node', [bundleScript].concat(args), {
      cwd: process.cwd(),
      stdio: 'inherit'
    }
  );
  if (result.signal === 'SIGKILL') {
    console.log(
      'The build failed because the process exited too early. ' +
      'This probably means the system ran out of memory or someone called ' +
      '`kill -9` on the process.'
    );
  } else if (result.signal === 'SIGTERM') {
    console.log(
      'The build failed because the process exited too early. ' +
      'Someone might have called `kill` or `killall`, or the system could ' +
      'be shutting down.'
    );
    process.exit(1);
  }
  process.exit(result.status);
}

function bundleReactCompiler(){
  const bundleScript = require.resolve('./react/index');
  
  let result = spawn.sync(
    'node', [bundleScript].concat(args), {
      cwd: process.cwd(),
      stdio: 'inherit'
    }
  );
  if (result.signal === 'SIGKILL') {
    console.log(
      'The build failed because the process exited too early. ' +
      'This probably means the system ran out of memory or someone called ' +
      '`kill -9` on the process.'
    );
  } else if (result.signal === 'SIGTERM') {
    console.log(
      'The build failed because the process exited too early. ' +
      'Someone might have called `kill` or `killall`, or the system could ' +
      'be shutting down.'
    );
    process.exit(1);
  }
  process.exit(result.status);
}





exports.bundleCompiler = bundleCompiler;
exports.bundleVueCompiler = bundleVueCompiler;
exports.bundleReactCompiler = bundleReactCompiler;