'use strict';

process.env.NODE_ENV = 'production';

process.on('unhandledRejection', err => {
  throw err;
});

const colors = require('chalk');
const rimraf = require('rimraf');
const createWebpackCompiler = require('../../start/react/create-webpack-compiler');
const paths = require('../../lib/webpack-config/react/paths');
const webpackConfigProd = require('../../lib/webpack-config/react/webpack.config.prod');

function build(config){
  const compiler = createWebpackCompiler(config);

  compiler.run(err => {
    if(err) {
      throw err;
    }

    console.log('');
    console.log(colors.green('Compiled successfully.'));
  });
}

rimraf(paths.appBuild, err => {
  if (err) {
    throw err;
  }
  build(webpackConfigProd);
});