'use strict';

const {execSync} = require('child_process')
const ui = require('../../lib/ui')
const wd = require('weex-devtool');

function checkPort(port){
  try{
    execSync(`lsof -i :${port} | grep node`);
    return true;
  }catch(e){
    return false;
  }
}

function startDevtoolServer(port){
  if(checkPort(port)){
    return Promise.resolve();
  }
  console.log(ui.yellow('调试服务启动中，编译完成后进入调试 server 地址，扫码调试: '));  
  return new Promise(function(resolve){
    wd.api.startServerAndLaunchDevtool('', '', port, function(){
      resolve();
    });
  });
}


exports.startDevtoolServer = startDevtoolServer;