'use strict';

exports.addPage = function*(pageArr){
  const yo = exports.yo;
  const config = require('../../config');
  const dsl = config.dsl();
  let template = '';

  if(dsl == 'react'){
    template = require.resolve('../lib/generator/react/page');
  }else if(dsl == 'vue'){
    template = require.resolve('../lib/generator/vue/page');
  }

  if(pageArr.length) {
    for(let i = 0, len = pageArr.length; i < len; i++) {
      let pageData = pageArr[i]
      yield yo(['--option', JSON.stringify(pageData)], template)
    }
  }else {
    yield yo([], template)
  }
}

exports.initProjectFromServer = function*(){
  const app = require('../../lib/app');
  
  let userApps = yield app.getApps();
  if(userApps.length){
    
    const rightpad = require('right-pad');
    let prompt_choices = userApps.map(function(app){
      return {name: `${rightpad(String(app.id), 4)}${rightpad(app.name, 25)}${rightpad(app.dsl, 4)}`, value: `${app.dsl}:${app.id}`};
    })
    const ui = require('../../lib/ui');
    let chosenApp = yield ui.list('获取线上平台已创建 app, 选择初始化的 app', prompt_choices);
    chosenApp = chosenApp.split(':')
    let chosenAppDsl = chosenApp[0];
    let chosenAppId = chosenApp[1];
    
    const config = require('../../config');
    let userNick = config.get('user_nick');
    let options = [];
    let template = '';

    if(chosenAppDsl == 'react') {
      options = ['--option', JSON.stringify({appId: chosenAppId, userNick: userNick})];
      template = require.resolve('../lib/generator/react/index');
    }else if(chosenAppDsl == 'vue'){
      options = ['--option', JSON.stringify({appId: chosenAppId, userNick: userNick})];
      template = require.resolve('../lib/generator/vue/index');
    }
  

    yield exports.yo(options, template);

    let doInstall = yield ui.confirm('是否自动安装依赖');
    if(!doInstall) {
      return;
    }
    const npm = require('../../lib/npm');
    console.log(ui.green('开始安装依赖...'));
    npm.install();

    let doCompile = yield ui.confirm('是否自动启动编译');
    if(!doCompile) {
      return;
    }
    const start = require('../start');
    console.log(ui.green('启动编译...'));
    start.startCompiler();
  }else {
    const ui = require('../../lib/ui');
    console.log(ui.yellow('您还没有在平台上创建 app ，请前往 http://amdp.alibaba.net/apps/ 创建 app 后重试'));
  }
}

exports.yo = require('./yo');