const util = require('util');
const path = require('path');
const yeoman = require('yeoman-generator');

function RaxGenerator(args, options, config){
  yeoman.generators.Base.apply(this, arguments);


  this.option('option', {type: String});
  this.boatOption = JSON.parse(this.options.option);

  this.appId = this.boatOption.appId;
  this.userNick = this.boatOption.userNick;
}
util.inherits(RaxGenerator, yeoman.generators.Base);

RaxGenerator.prototype.askFor = function(){
  let cb = this.async();
  let self = this;

  let prompts = [
    {
      type: 'input',
      name: 'name',
      message: 'name: 项目名称',
      default: path.basename(process.cwd())
    },
    {
      type: 'input',
      name: 'author',
      message: 'author: 作者名称',
      default: self.userNick
    }
  ]

  this.prompt(prompts, function(props){
    self.name = props.name;
    self.author = props.author;
    cb();
  });
  this.gitignore = ["node_modules/",
                        "build/",
                        ".travis.yml",
                        "*.swp",
                        ".sass-cache/",
                        ".DS_Store",
                        ".idea/",
                        "zip/",
                        "*.tmp",
                        "*.bak",
                        "tmp/",
                        "temp/",
                        "coverage/",
                        ];
}

function generator(){
  this.template('package.json', 'package.json');
  // this.template('.eslintrc.js', '.eslintrc.js');
  this.template('README.md', 'README.md');

  this.directory('src/pages/detail', 'src/pages/detail');
  this.directory('src/pages/index', 'src/pages/index');
  this.directory('public', 'public');
  
}

RaxGenerator.prototype.app = function app(){
  let cb = this.async();
  generator.call(this);
  cb();
}

module.exports = RaxGenerator;