const util = require('util');
const path = require('path');
const yeoman = require('yeoman-generator');

function RaxPageGenerator(args, options, config){
  yeoman.generators.Base.apply(this, arguments);
}
util.inherits(RaxPageGenerator, yeoman.generators.Base);

function testName(name) {
  if (/[A-Z]/.test(name)) {
    console.log('页面名称: ' + name + ' 不能包含大写字幕或者使用驼峰命名，请使用 ‘-’ 作为连接符');
    return false;
  }
  return true;
}

RaxPageGenerator.prototype.askFor = function(){
  let cb = this.async();
  let self = this;

  let prompts = [
    {
      type: 'input',
      name: 'name',
      message: 'name: 页面名称',
      validate: function (input) {
        if (!input) {
          return '不允许为空';
        }
        if (/[A-Z]/.test(input)) {
          return '' + input + ' 不允许使用驼峰形式命名哦，请使用 ‘-’ 作为连接符';
        }
        return true;
      }
    }
  ]

  this.prompt(prompts, function(props){
    self.pageName = props.name;
    cb();
  });

}

function generator(){
  let cwd = process.cwd();
  let pagename = this.pageName
  let pageDir = path.join(cwd, 'src/pages', pagename);

  this.mkdir(pageDir);
  this.template('src/pages/page/App.js', path.join(pageDir, 'App.js'));
  this.template('src/pages/page/index.js', path.join(pageDir, 'index.js'));
  this.template('src/pages/page/App.css', path.join(pageDir, 'App.css'));
}

RaxPageGenerator.prototype.app = function app(){
  let cb = this.async();
  generator.call(this);
  cb();
}

module.exports = RaxPageGenerator;