'strict'

const util = require('util');
const path = require('path');
const yeoman = require('yeoman-generator');

function VueGenerator(args, options, config){
  yeoman.generators.Base.apply(this, arguments);

  this.option('option', {type: String});
  this.boatOption = JSON.parse(this.options.option);

}

util.inherits(VueGenerator, yeoman.generators.Base);

VueGenerator.prototype.askFor = function(){
  let cb = this.async();
  let self = this;
  
  let prompts = [
    {
      type: 'input',
      name: 'name',
      message: 'name: 项目名称',
      default: path.basename(process.cwd())
    },
    {
      type: 'input',
      name: 'author',
      message: 'author: 作者名称',
    }
  ]

  this.prompt(prompts, function(props){
    self.name = props.name;
    self.author = props.author;
    cb();
  });
}

function generator(){
  this.template('app/package.json', 'package.json');
  // this.template('.eslintrc.js', '.eslintrc.js');
  this.template('app/README.md', 'README.md');

  this.directory('app/src', 'src');
  this.directory('app/public', 'public');
  this.directory('page', 'src/pages/index');
}

VueGenerator.prototype.app = function app(){
  let cb = this.async();
  generator.call(this);
  cb();
}

module.exports = VueGenerator;