const util = require('util');
const path = require('path');
const yeoman = require('yeoman-generator');

function VuePageGenerator(args, options, config){
  yeoman.generators.Base.apply(this, arguments);
  
  this.option('option', {type: String})

  if(this.options.option) {
    this.pageOption = JSON.parse(this.options.option)
  }
}

util.inherits(VuePageGenerator, yeoman.generators.Base);

VuePageGenerator.prototype.askFor = function(){
  if(this.pageOption) {
    this.pageName = this.pageOption
    return
  }

  let cb = this.async();
  let self = this;
  
  let prompts = [
    {
      type: 'input',
      name: 'name',
      message: 'name: 页面名称',
      validate: function (input) {
        if (!input) {
          return '不允许为空';
        }
        //TODO 页面已存在检测
        if (/[A-Z]/.test(input)) {
          return '' + input + ' 不允许使用驼峰形式命名哦，请使用 ‘-’ 作为连接符';
        }
        return true;
      }
    }
  ]

  this.prompt(prompts, function(props){
    self.pageName = props.name;
    cb();
  });
}

function generator(){
  let cwd = process.cwd();
  let pagename = this.pageName
  let pageDir = path.join(cwd, 'src/pages', pagename);

  this.mkdir(pageDir);
  this.template('page/App.vue', path.join(pageDir, 'App.vue'));
  this.template('page/index.native.js', path.join(pageDir, 'index.native.js'));
  this.template('page/index.web.js', path.join(pageDir, 'index.web.js'));
}

VuePageGenerator.prototype.app = function(){
  let cb = this.async();
  generator.call(this);
  cb();
}

module.exports = VuePageGenerator;