'use strict';

const path = require('path');
const address = require('address');
const webpack = require('webpack');
const paths = require('./paths');
const webpackConfigBase = require('./webpack.config.base');
const options = require('../../../../lib/parse-options');
const RaxHotModuleReplacementPlugin = require('rax-hot-module-replacement-webpack-plugin');

const webpackConfigDev = Object.assign({}, webpackConfigBase);
const ipv4 = address.ip();
const port = options.port;
const webUrl = 'http://' + ipv4 + ':' + port;
const bundleUrl = 'http://' + ipv4 + ':' + port + '/js/index.bundle.js';
const weexBundleUrl = `${bundleUrl}?_wx_tpl=${bundleUrl}`;
const LiveReloadPlugin = require('webpack-livereload-plugin');


// enable source map
webpackConfigDev.devtool = 'inline-module-source-map';
webpackConfigDev.entry = paths.entry;
// {
//   'main/index':   [path.join(process.cwd(), 'src/pages/main', 'index.js')],
//   'detail/index': [path.join(process.cwd(), 'src/pages/detail', 'index.js')]
// }

/*
// Module hot accept
webpackConfigDev.module.loaders.forEach(loader => {
  if (loader.test.toString() === /\.jsx?$/.toString()){
    loader.loaders.push(`${require.resolve('../start/loaders/module-hot-accept')}`);
  }
})

Object.keys(webpackConfigDev.entry).forEach(point => {
  // Enable hot reloading
  webpackConfigDev.entry[point].unshift(require.resolve('rax-hot-loader/patch'));
  // webpackConfigDev.entry[point].unshift(`${require.resolve('webpack-dev-server/client')}?${options.protocol}//${options.host}:${options.port}`);
  // // bundle the client for webpack-dev-server
  // // and connect to the provided endpoint
  // webpackConfigDev.entry[point].unshift(require.resolve('webpack/hot/only-dev-server'));
  // // bundle the client for hot reloading
  // // only- means to only hot reload for successful updates

  // hot reaload client.
  webpackConfigDev.entry[point].unshift(require.resolve('../start/dev-utils/webpackHotDevClient'));
});

// Only work on web
webpackConfigDev.plugins.push(new RaxHotModuleReplacementPlugin());
*/


webpackConfigDev.plugins.push(new webpack.NoEmitOnErrorsPlugin());
webpackConfigDev.plugins.push(new webpack.DefinePlugin({
  'process.env': {
    NODE_ENV: JSON.stringify('development')
  }
}))
webpackConfigDev.plugins.push(new LiveReloadPlugin({appendScriptTag: true}));



module.exports = webpackConfigDev