'use strict';
const path = require('path');
const webpack = require('webpack');

const paths = require('./paths');
const webpackConfigBase = require('./webpack.config.base');

const webpackConfigProd = Object.assign({}, webpackConfigBase);


webpackConfigProd.entry = paths.entry;
webpackConfigProd.output.pathinfo = false;
webpackConfigProd.target = 'node';

webpackConfigProd.plugins.push(
  new webpack.optimize.UglifyJsPlugin({
    include: /\.min\.js$/,
    minimize: true,
    compress: {
      warnings: false
    }
  })
)
webpackConfigProd.plugins.push(new webpack.DefinePlugin({
  'process.env': {
    NODE_ENV: JSON.stringify('production')
  }
}));

module.exports = webpackConfigProd;