const merge = require('webpack-merge')
const options = require('../../../../lib/parse-options')
const CleanWebpackPlugin = require('clean-webpack-plugin')
const configs = require('./webpack.base.config')
const webpack = require('webpack')
const config = require('./config')

var webConfig = configs[0]
var nativeConfig = configs[1]

webConfig = merge(webConfig, {
  // devtool: 'source-map',
  devtool: 'none',
  plugins: [
    new webpack.DefinePlugin({
      'process.env': config.dev.env
    }),
    new webpack.HotModuleReplacementPlugin(),
    new webpack.NoEmitOnErrorsPlugin(),
  ]
})

Object.keys(webConfig.entry).forEach(function (name) {
  webConfig.entry[name] = ["webpack-dev-server/client?http://" + require("ip").address() + ":" + options.port + "/", "webpack/hot/dev-server"].concat(webConfig.entry[name])
})

module.exports = [webConfig, nativeConfig]
