var webpack = require('webpack')
var CleanWebpackPlugin = require('clean-webpack-plugin')
const UglifyJSPlugin = require('uglifyjs-webpack-plugin')
var merge = require('webpack-merge')
var config = require('./config')
var configs = require('./webpack.base.config')

var webConfig = configs[0]
var nativeConig = configs[1]

var env = config.build.env

webConfig = merge(webConfig, {
  devtool: config.build.productionSourceMap ? '#source-map' : false,
  plugins: [
    new CleanWebpackPlugin(['build'], {
      root: config.build.publicRoot,
      verbose: false
    }),
    new webpack.DefinePlugin({
      'process.env': env
    })
    ,new UglifyJSPlugin({
      comments: false
    })
  ]
});

nativeConig = merge(nativeConig, {
  plugins: [
    new CleanWebpackPlugin(['build'], {
      root: config.build.publicRoot,
      verbose: false
    }),
    new webpack.DefinePlugin({
      'process.env': env
    }),
    new UglifyJSPlugin({
      comments: new RegExp('\\s\\{\\s"framework":\\s"Vue"\\s\\}')
    })
  ]
});


module.exports = [
  webConfig, 
  nativeConig
]
