const args = process.argv.slice(3);

function startCompiler(param){
  const config = require('../../config');
  const dsl = config.dsl();

  if(dsl == 'react'){
    startReactCompiler(param);
  }else if(dsl == 'vue'){
    startVueCompiler(param);
  }
}


function startVueCompiler(param){
  const startScript = require.resolve('./vue/index');
  const spawn = require('cross-spawn');

  let env = Object.assign({}, process.env);
  if(param.port) {
    env.PORT = param.port;
  }
  env.BOAT_CUSTOMPAGE = param.customPage
  
  let child = spawn(
    'node', [startScript].concat([]), {
      cwd: process.cwd(),
      env: env,
      stdio: 'inherit'
    }
  );

  child.on('close', function(code){
    if(code !== 0) {
      process.exit(code);
    }
  })
  
  
}

function startReactCompiler(param){
  const startScript = require.resolve('./react/index');
  const spawn = require('cross-spawn');

  let env = Object.assign({}, process.env);
  if(param.port) {
    env.PORT = param.port;
  }

  let result = spawn.sync(
    'node', [startScript].concat(args), {
      cwd: process.cwd(),
      env: env,
      stdio: 'inherit'
    }
  );
  
  process.exit(result.status);
}


exports.startCompiler = startCompiler;
exports.startVueCompiler = startVueCompiler;
exports.startReactCompiler = startReactCompiler;
