'use strict';

const got = require('got');
const template = require('lodash.template');
const debug = require('debug')('boat-cli:app');
const config = require('../../config');
const user_token = config.get('user_token');
const env = config.env;

// 获取 server 信息
const server = getServer(process.argv);

let API = {
  apps: `${getServer}/api/app`,
  appDetail: template(`${getServer}api/app/<%= appId%>`)
};

exports.getApps = function(){
  return got(API.apps, {
    query: {
      token: user_token
    },
    timeout: 5000,
    json: true,
  }).then(function(res){
    res = res.body;
    debug('apps', res.data);
    if(!res.error) {
      return res.data;
    }else {
      return [];
    }
  })
}

exports.getAppInfo = function(appId){
  return got(API.appDetail({appId: appId}), {
    timeout: 5000,
    query: {
      token: user_token
    },
    json: true
  }).then(function(res){
    res = res.body;

    return res;
  })
}