'use strict';
const spawn = require('cross-spawn');
const cnpmcmd = require.resolve('cnpm/bin/cnpm');

exports.install = function(env){
  env = ['development', 'production'].indexOf(env) != -1 ? env : 'production';

  let result = spawn.sync(
    'node', [cnpmcmd, 'i', `--${env}`], {
      cwd: process.cwd(),
      stdio: 'inherit'
    }
  )

  return !result.error && result.status == 0;
}

exports.update = function(){
  let result = spawn.sync(
    'node', [cnpmcmd, 'update', '--production'], {
      cwd: process.cwd(),
      stdio: 'inherit'
    }
  )
}
