'use strict';

const path = require('path');
const cp = require('child_process');
const fs = require('fs');
const {gitDir} = require('../config');
const git = require('simple-git')();
const download = require('download');
const tar = require('tar-fs');


//TODO: 可执行测试
// if(process.platform == 'win32') {
//   git.customBinary(path.join(__dirname, './git/win/PortableGit-1.9.5-preview20141217/bin/git.exe'));  
// }else {
//   git.customBinary(path.join(__dirname, './git/osx/git-2.13.1-intel-universal-mavericks/bin/git'));
// }

// git.status((err, status)=>{
//   console.log(status);
// })

function downloadBuiltInGit(){
  let downloadPath = ''
  if(process.platform == 'darwin') {
    downloadPath = 'http://git.cn-hangzhou.oss-cdn.aliyun-inc.com/uploads/shangpo.zw/record/cb8297f85a5f039d3553d1901fd71c33/osx.tar.gz';
  }else {
    
  }

  return new Promise(function(resolve, reject){
    download(downloadPath)      
    .pipe(zlib.createGunzip())
    .on('error', function(err){
      console.log('gunzip');
      console.log(err);
      reject(err)
    })
    .pipe(tar.extract(gitDir))
    .on('error', function(err){
      console.log('tar');
      reject(err);
    })
    .on('finish', function(){
      resolve();
    })
  });
}

function* getBin(){
  let binPath = '';

  if(process.platform == 'darwin') {
    binPath = path.join(gitDir, 'osx', 'git-2.13.1-intel-universal-mavericks','bin','git');
  }
  if(!fs.existsSync(binPath)) {
    console.log('本地不存在内置 git，开始下载内置 git');
    yield downloadBuiltInGit();
  }
  // path.join(__dirname, './git/osx/git-2.13.1-intel-universal-mavericks/bin/git')
  return binPath
}


exports.git = function(cwd){
  git.cwd(cwd);
  return git;
}
exports.getBin = getBin
exports.downloadBuiltInGit = downloadBuiltInGit;
