'use strict';
const path = require('path');
const spawn = require('cross-spawn');
const rimraf = require('rimraf');
const cwd = process.cwd();

exports.install = function(env){
  env = ['development', 'production'].indexOf(env) != -1 ? env : 'production';
  // --registry=https://registry.npm.taobao.org
  let registry = process.env.BOAT_NPM_REGISTRY || 'https://registry.npm.taobao.org' 
  let result = spawn.sync(
    'npm', ['i', `--${env}`, '--no-package-lock', `--registry=${registry}`], {
      cwd: cwd,
      stdio: 'inherit'
    }
  )

  return !result.error && result.status == 0;
}
exports.update = function(env){
  env = ['development', 'production'].indexOf(env) != -1 ? env : 'production';

  try{
    rimraf.sync(path.join(cwd, 'node_modules'));
  } catch(e){
    return false;
  }

  let registry = process.env.BOAT_NPM_REGISTRY || 'https://registry.npm.taobao.org' 
  
  let result = spawn.sync(
    'npm', ['i', `--${env}`, '--no-package-lock', `--registry=${registry}`], {
      cwd: cwd,
      stdio: 'inherit'
    }
  )

  return !result.error && result.status == 0;
}
