const inquirer = require('inquirer');
const Ora = require('ora');
const chalk = require('chalk');

exports.input = function(msg, defaultVal){
  return inquirer.prompt([{
    type: 'input',
    name: 'result',
    message: msg,
    default: defaultVal
  }]).then(answer => answer.result);
}

exports.list = function(msg, choices, defaultVal){
  return inquirer.prompt([{
    type: 'list',
    name: 'result',
    message: msg,
    choices: choices,
    default: defaultVal
  }]).then(answer => answer.result);
}

exports.confirm = function(msg){
  return inquirer.prompt([{
    type: 'confirm',
    name: 'ok',
    message: msg
  }]).then(answer => answer.ok);
}

exports.spinner = function(desc){
  return Ora(desc).start();
}

exports.chalk = chalk;
exports.red = chalk.red;
exports.yellow = chalk.yellow;
exports.green = chalk.green;