const path = require('path');
const nunjucks = require('nunjucks');
const koa = require('koa');
const router = require('koa-router')();

let app = koa();

nunjucks.configure(path.join(__dirname, 'views'), {
  noCache: true
});

app.context.render = function*(view, data){
  this.body = nunjucks.render(view, data);
}

router.get('/token', function*(next){
  yield this.render('token.html');
})
router.get('/token/manual', function*(next){
  yield this.render('manual_token.html');
})
router.get('/token/check', function*(next){
  console.log('this.query.user_token',  this.query.user_token);
  this.body = {
    success: false
  }
})

router.get('/api/apps', function*(next){

})

app.use(router.routes());

app.listen(6677, function(){
  console.log('listen on 6677');
});